#include <stdexcept>
#include <iomanip>

#include "matrix.h"

/// - constructor --------------------------------------------------------------
Matrix::Matrix() : ROWS(10), COLS(10) 
{
   values = new double(ROWS * COLS);
}
   
Matrix::Matrix(int r, int c) : ROWS(r), COLS(c)
{
   values = new double[ROWS * COLS];
}

/// - destructor ---------------------------------------------------------------
Matrix::~Matrix()
{
   delete[] values;
   std::cout << " Matrix destructor called" << std::endl;
}

/// - public method ------------------------------------------------------------
double Matrix::getValueAt(int r, int c) const 
{
   if ( (r < 0 or r >= ROWS or c < 0 or c >= COLS)) {
      throw std::out_of_range("Are you stupid?");
   }
   return values[ r * COLS + c];
}

/// - public method ------------------------------------------------------------
void Matrix::print(std::ostream & out)
{ 
   for (int r = 0; r < ROWS; ++r) {
      for (int c = 0; c < COLS; ++c) {
         out 
            << std::fixed << std::setw(6) << std::setprecision(2) 
            << values[r * COLS + c] << " ";
      }
      out << std::endl;
   }
}

/// - private method -----------------------------------------------------------


